<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8"> 
  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <!-- Meta -->
  <title>GNOME + GSoC | 2025 Project Ideas</title>
  <meta name="title" content="GNOME GSoC 2025 Project Ideas">
  <meta itemprop="name" content="GNOME GSoC 2025 Project Ideas">
  <meta name="description" content="Project ideas for Google Summer of Code 2025 with GNOME">
  <meta itemprop="description" content="Project ideas for Google Summer of Code 2025 with GNOME">

  <!-- Twitter -->
  <meta property="twitter:title" content="GNOME GSoC">
  <meta property="twitter:image" content="https://gsoc.gnome.org/card.png" />
  <meta property="twitter:description" content="Project ideas for Google Summer of Code 2025 with GNOME">

  <!-- Open Graph -->
  <meta property="og:title" content="GNOME GSoC 2025 Project Ideas">
  <meta property="og:url" content="https://gsoc.gnome.org/2025/">
  <meta property="og:description" content="Participate in Google Summer of Code with GNOME">

  <link rel="stylesheet" href="https://static.gnome.org/css/inter.css">
  <link rel="stylesheet" href="https://gsoc.gnome.org/gnome.css">
  <link rel="icon" type="image/png" href="https://gsoc.gnome.org/favicon.svg" />
  <link rel="apple-touch-icon" href="https://gsoc.gnome.org/apple-touch-icon.png" sizes="180x180">
</head>
<body>
  <div class="wrapper">
    <main aria-label="Content">
      <article class="post-item">
        <h1 class="post-item-title">GNOME Project ideas for Google Summer of Code 2025</h1>

        <p>For general information on how to get involved  with our project and participate in <a href="https://summerofcode.withgoogle.com/">Google Summer of Code</a> with <a href="https://gnome.org">GNOME</a> visit <a href="https://gsoc.gnome.org">gsoc.gnome.org</a></p>


        <p>This is the list of project ideas that the GNOME community is interested in mentoring. GSoC interns can also propose their very own project ideas. If you are interested in proposing a project idea, please file an issue in our <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas">Internship Project Ideas repository.</a></p>

        <p>GSoC contributors proposing something original must engage with the community strongly before or during the application period to get feedback and guidance to improve the proposal.</p>

        <h2>Project list</h2>
        <ul>
          <li><a href="#ebpf-profiling-sysprof">Add eBPF profiling capabilities to Sysprof</a></li>
          <li><a href="#papers-backend-isolation">Papers: Proof of Concept for backend isolation</a></li>
          <li><a href="#vala-xml-json-yaml-integration">Vala: Researching/Designing/Implementing xml/json/yaml/... integration</a></h1></li>
          <li><a href="#crosswords-add-printing-support">Add printing support to GNOME Crosswords</a></li>
          <li><a href="#crosswords-add-wordlist-scoringt">Add Wordlist Scoring to GNOME Crosswords Editor</a></li>
          <li>Project proposals will be listed here.</li>

        </ul>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="ebpf-profiling-sysprof"><a href="#ebpf-profiling-sysprof">Add eBPF profiling capabilities to Sysprof</a></h1>

        <p>Currently, Sysprof works by recording stack traces from the Linux Perf subsystem using perf_event_open(). It also can record various system statistics using data from /proc such as CPU, memory, networking, and disk statistics.</p>

        <p>eBPF provides an existing new direction for tooling of this nature by uploading small programs into the kernel to extract the data you want without the parsing overhead. That data can be delivered to an application like Sysprof for recording into the capture files.</p>

        <p>This internship would involve creating the tooling within libsysprof to setup new eBPF programs by compiling, linking, and uploading them into the kernel along with necessary components to get data from the kernel back to Sysprof.</p>

        <p>This would then be used to port some collectors such as CPU or memory trackers to use eBPF instead of /proc files.</p>

          <h3>Requirements</h3>

          <ul>
            <li>Knowledge of C, preferably using GLib/GObject but that can be learned</li>
            <li>Minimal experience performance profiling software</li>
            <li>Minimal experience with the Linux kernel</li>
            <li>Learning how eBPF works and how to integrate that with the kernel can be learned on the job</li>
          </ul>

          <h3>Communication</h3>
          <p>Chat, email, video chat. Christian Hergert @chergert or hergertme on IRC/Matrix or @chergert at gnome.org</p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/chergert">Christian Hergert</a></h3>

          <h3>Difficulty: Hard</h3>
          <h3>Mentor availability: ~350 hours</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/51">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/51</a>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="papers-backend-isolation"><a href="#papers-backend-isolation">Papers: Proof of Concept for backend isolation</a></h1>

        <p>This project will mostly require work on Papers' libraries: ppsview and ppsdocument. The former contains an abstraction (PpsJob) to run (potentially slow) backend code in threads. The later is basically a common abstraction over different backends: PDF, DJVU, Tiff, etc. The idea is to create a component that will start a new process per-document (similar to web-browsers having one process per tab!). That side-car process will take care of all the calls to the backends (so embedded in ppsdocument), and be managed by PpsJobs. Further details are available in https://gitlab.gnome.org/GNOME/Incubator/papers/-/issues/104</p>

        <p>The idea for the GSoC will be for the Intern to prototype a solution to this problem, and investigate potential solutions and foot-guns. The intern will need quite a good knowledge on C, and have motivation to do some investigate work (e.g: look into solutions implemented by other projects like WebKit). I don't expect a full implementation or solution, even if that would be welcomed. A failed attempt at this might already gives us extremely valuable input.</p>

        <p>This will benefit Papers as the future Document Viewer in GNOME in two ways:</p>

        <ul>
          <li>By isolating documents from each other, we improve the overall security situation. Even CVEs that might allow somebody to gain access to execution code from rendering a PDF would not have access to the other documents.</li>
          <li>By isolating documents from the UI we improve the resilience of Papers. A document crashing during rendering (for which CVEs happen regularly (last one CVE-2024-6239) will not bring down with itself the complete application. This has been so far the main blocker to implement the Document Viewer tabbed view, which has been a feature request for Evince since 2005</li>
        </ul>

          <h3>Requirements</h3>

          <ul>
            <li>Good skill and experience in the C programming language. Both be able to write and read it</li>
            <li>The ability to investigate previous approaches to solve the same issue. We will guide the Intern on where to look</li>
            <li>Motivation to try different approaches. We know a big part of this project will be checking the feasibility of different solutions</li>
          </ul>

          <h3>Communication</h3>
          <p>Our preferred communication channel is Matrix (https://matrix.to/#/#papers:gnome.org), but we will also do video-calls to get onboarded and if deemed useful and necessary for the mentoring process</p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/pabloyoyoista">Pablo Correa Gomez</a>, <a href="https://gitlab.gnome.org/crab2313">Qiu</a> and <a href="https://gitlab.gnome.org/camelCaseNick">Markus</a></h3>

          <h3>Difficulty: Hard</h3>
          <h3>Mentor availability: ~350 hours</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/58">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/58</a>
      </article>

      <article>
        <h1 class="post-item-title" id="vala-xml-json-yaml-integration"><a href="#vala-xml-json-yaml-integration">Vala: Researching/Designing/Implementing xml/json/yaml/... integration</a></h1>
        <p>The goal of this project is to add xml, json and/or yaml format language integration to Vala. Other integrations already exist for DBus, GTK builder format, or GModule (https://gnome.pages.gitlab.gnome.org/vala/manual/attributes.html#dbus-attribute). Examples can be found here.</p>
        <p>Currently, parsing and emitting files in Vala with formats like xml, json, or yaml are relatively tedious, need a lot of boilerplate code, and are much more complicated than in other programming languages. But these file formats are very commonly used in modern software, and many internet protocols and existing standards depend on them. Improving their handling would allow more efficient development, as well as lower the barrier for newcomers to Vala.</p>
        <p>First, research is necessary, to find out how other programming languages have done the integrations. Also wanted features will need to be evaluated. For that also different example projects need to be looked into or created, to find the different use cases and related challenges and how to address them. For proposing designs of the new Syntax, "code mock-ups" are going to be written. These can later also serve as test cases for the vala test suite. Then the community will discuss and give feedback to iterate on the syntax design. As the last step (and probably the one taking the longest time), the proposed syntax('s) will be prototyped inside the Vala compiler. Also test cases for the new features, documentation and example code snippets should be developed at the end of the project. If time is left at the end, also other projects that benefit from the new features can be updated to use the new syntax, for example the Vala Language Server.</p>

        <h3>Requirements</h3>

        <ul>
          <li>Experience with programming in general, as well as a good understanding of object orientation</li>
          <li>Ready to learn the Vala language, and to understand and investigate the syntax of other programming languages for research purposes</li>
          <li>Being open to reach out to the Vala community, and to contributors of other projects written in Vala, to collect feedback about the current situation and the new syntax</li>
          <li>Ability to grow familiar with a relatively large codebase, to find solutions to problems you encounter (There will be a lot of guidance of course)</li>
        </ul>

        <h3>Communication</h3>

        <p>Main communication channel: Matrix: https://matrix.to/#/#vala:gnome.org Calls are possible for onboarding and mentoring whenever there is a need. (And when enough time)</p>

        <h3>Mentor(s): <a href="https://gitlab.gnome.org/lwildberg">Lorenz Wildberg</a></h3>

        <h3>Difficulty: Medium</h3>
        <h3>Mentor availability</h3> TBD

        <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/internship/project-ideas/-/issues/61">https://gitlab.gnome.org/Teams/internship/project-ideas/-/issues/61</a>
      </article>

        <article>
        <h1 class="post-item-title" id="crosswords-add-printing-support"><a href="#crosswords-add-printing-support">Add printing support to GNOME Crosswords</a></h1>
        <p>GNOME Crosswords has some cursory svg code, but doesn't support printing. It is relatively straightforward to extend the svg code to produce printable puzzles. This project consists of multiple sequential stages, with some simple initial milestones and some stretch goals as well. In particular:</p>
        <ul>
          <li>Initial design and planning</li>
          <li>Refactor the svg code to make it handle the existing board and thumbnail usecases, as well as printable puzzles</li>
          <li>Add clues to the generated svg, and make it look good</li>
          <li>Bring the printing dialog to both the game and the editor</li>
          <li>Add crossword-specific options to the printing flow</li>
        </ul>
        <p>As stretch goals, it would be good to support additional puzzle types, as well as add an ipuz2pdf utility to the app.</p>

        <h3>Requirements</h3>

        <ul>
          <li>Knowledge of C, especially glib-style C programming. Ability to understand a complex codebase and issues.</li>
          <li>Familiarity with svg a plus</li>
          <li>A physical printer is not necessary</li>
        </ul>

        <h3>Communication</h3>

        <p>Primarily matrix. The main crosswords channel can be found at https://matrix.to/#/#crosswords:gnome.org</p>
        <p>We also will use gitlab issues and email as appropriate. Video conferencing occasionally when necessary.</p>

        <h3>Mentor(s): <a href="https://gitlab.gnome.org/jrb">Jonathan Blandford</a>, <a href="https://gitlab.gnome.org/federico">Federico Mena Quintero</a>, <a href="mailto:tanmayp@gnome.org">tanmayp@gnome.org</a></h3>

        <h3>Difficulty: Medium</h3>
        <h3>Mentor availability: ~350 hours (Could be ~175 hours if necessary, with fewer milestones reached</h3>

        <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/internship/project-ideas/-/issues/62">https://gitlab.gnome.org/Teams/internship/project-ideas/-/issues/62</a>
      </article>

      <article>
        <h1 class="post-item-title" id="crosswords-add-wordlist-scoring"><a href="#crosswords-add-wordlist-scoringt">Add Wordlist Scoring to GNOME Crosswords Editor</a></h1>
        <p>GNOME Crosswords Editor uses some lists of words in order to produce crosswords. These lists lack the metadata to make more interesting puzzles. We'd like to find, gather, and encode that metadata with the lists in order to choose appropriate words when working with the editor.</p>

        <p>For more information on the problem, please read <a href="https://jrb.pages.gitlab.gnome.org/crosswords/devel-docs/word-scores.html">this design doc.</a></p>

        <p>This project will involve finding ways to calculate, measure, and encode values for each of the five traits listed. We will then use it when creating a puzzle to try and create more interesting grids.</p>

        <h3>Requirements</h3>

        <ul>
          <li>The biggest requirement for this project is a love of words, and a certain amount of comfort with uncertainty. I will expect the intern to do some independent research and exploration</li>
          <li>This project will mostly be in python, and will involve a fair amount of data analysis as well as codings</li>
          <li>Some low-level C programming knowledge is a strong plus, as well as the ability to use a hex-editor. The current wordlist is stored in a custom data structure</li>
          <li>This project will involve working with some large data sets — possibly as big as 20 GB. A relatively fast machine with sufficient disk space will be required, as well as the ability to download large files.</li>
        </ul>

        <h3>Communication</h3>

        <p>Primarily matrix. The main crosswords channel can be found at https://matrix.to/#/#crosswords:gnome.org</p>
        <p>We also will use gitlab issues and email as appropriate. Video conferencing occasionally when necessary.</p>

        <h3>Mentor(s): <a href="https://gitlab.gnome.org/jrb">Jonathan Blandford</a>, <a href="https://gitlab.gnome.org/federico">Federico Mena Quintero</a>, <a href="mailto:tanmayp@gnome.org">tanmayp@gnome.org</a></h3>

        <h3>Difficulty: Medium</h3>
        <h3>Mentor availability: ~350 hours (Could be ~175 hours if necessary, with fewer milestones reached</h3>

        <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/internship/project-ideas/-/issues/63">https://gitlab.gnome.org/Teams/internship/project-ideas/-/issues/63</a>
      </article>
    </main>
  </div>
</body>

</html>
